FxU32 NextTextureOffset = 0;


typedef struct TextureMap_type
{
  GrTexInfo TexInfo;
  FxU32 VideoMemoryAddressTMU0;
  void *TextureData;

} TextureMap;


void  LoadTexture(char *FileName, TextureMap *Texture);


void  LoadTexture(char *FileName,TextureMap *Texture )
{	
	Gu3dfInfo TexInfo;
	GrTexInfo SizeInfo;

	long Startaddress;
	long TextureSize;

	// Note that these Setuproutines for the pixelpipline shouldn't be here !
	// But this way this file easer to use...
	grTexFilterMode(GR_TMU0,GR_TEXTUREFILTER_BILINEAR,
				GR_TEXTUREFILTER_BILINEAR);

    	// Setup TMU0 for simple texture mapping
    	grTexCombine(GR_TMU0,	GR_COMBINE_FUNCTION_LOCAL,
				GR_COMBINE_FACTOR_NONE,
				GR_COMBINE_FUNCTION_LOCAL,
				GR_COMBINE_FACTOR_NONE,
				FXFALSE,FXFALSE);

	grTexClampMode(GR_TMU0,GR_TEXTURECLAMP_WRAP,GR_TEXTURECLAMP_WRAP);

	gu3dfGetInfo(FileName,&TexInfo);

	// allocate memory for the mipmap:
	TexInfo.data = (void*)malloc(TexInfo.mem_required);

	// Load the mipmap from disk:
	gu3dfLoad(FileName,&TexInfo);

	Texture->TexInfo.data			= TexInfo.data;
	Texture->TexInfo.format			= TexInfo.header.format;
	Texture->TexInfo.aspectRatioLog2	= TexInfo.header.aspect_ratio;
	Texture->TexInfo.smallLodLog2		= TexInfo.header.small_lod;
	Texture->TexInfo.largeLodLog2		= TexInfo.header.large_lod;
	Texture->VideoMemoryAddressTMU0		= NextTextureOffset;

	// Gether some information needed to calculate ths size of the texture
	// and add the size to the TextureOffset
	SizeInfo.smallLodLog2		= TexInfo.header.small_lod;
	SizeInfo.largeLodLog2		= TexInfo.header.large_lod;
	SizeInfo.aspectRatioLog2	= TexInfo.header.aspect_ratio;
	SizeInfo.format			= TexInfo.header.format;
	SizeInfo.data			= TexInfo.data;

	grTexDownloadMipMap(GR_TMU0,NextTextureOffset,GR_MIPMAPLEVELMASK_BOTH,&Texture->TexInfo);

	NextTextureOffset += grTexTextureMemRequired(GR_MIPMAPLEVELMASK_BOTH, &SizeInfo);

}


